/*
	withmdic.c
	ryu@pdaprogramming.com
	
	ť v100  mDic  
*/

#include <cvos.h>
#include "withmdic.h"
#include "EDictLib_stub.h"

#define EKDICT50_NAME			"NAED"
#define DICV_APPP_ID			"EKDA"

#define REQ_WORD_MEAN				5252
#define REQ_DRAW_PRON				5253

typedef struct tagProWord {
	unsigned char *pro; // ܾ ȣ
	int x;		// x ǥ
	int y;		// y ǥ
	int width;
} PROWORD, *PPROWORD;

/*
	Ÿ ġǾ ִ Ȯ
*/
STATUS SeekDict( void )
{
	int		version;
	char	app50[5] = EKDICT50_NAME;

	if( FindLibrary( *((P_U32)app50), (P_U32)&version, (P_U32)gEDLibFuncVec) == CVOS_OK ) 
	{ 
		InitDictionary(); 
		return CVOS_OK; 
	}
	return CVOS_ERROR;
}

/*
	 ܾ ˻
	
	-  SeekDict ȣ
*/
STATUS SeekWord( char *word, char *pron, char *expl, char impo )
{
	int rtn;
	char* pDataBuf = NULL;
	
	rtn = Search( (const char*)word, &pDataBuf );

	if( rtn <= 0 ) 
		return DICT_WORD_NOT_FOUND;
	
	SeperateString( pDataBuf, word, &impo, pron, expl );
	Lfree( pDataBuf );
	
	return CVOS_OK;
}

/*
	ȣ ȭǥ x,y  ׷ش.
*/
STATUS DrawPron( char *pron, int x, int y, int width )
{
	PROWORD ProWord;
	
	memset( &ProWord, 0, sizeof( PROWORD ) );
	ProWord.pro = pron;
	ProWord.x = x;
	ProWord.y = y;
	ProWord.width = width;
	
	return RequestToApplication( *((P_U32)DICV_APPP_ID), REQ_DRAW_PRON, (P_U32)((P_U8)(&ProWord)));
}

/*
	ܾ ǹ̸ ش.
*/
STATUS ShowMeaning( char *word )
{
	return RequestToApplication( *((P_U32)DICV_APPP_ID), REQ_WORD_MEAN, (P_U32)((P_U8)(word)));
}




	

