/*************************************************************************
 *
 * Copyright (c) 1997-2001 Jtel Corporation or its subsidiaries.
 * All rights reserved.
 *
 * DESC:
 *
 ************************************************************************/
#include "AppMain.h"
#include "withmdic.h"

char word[MAX_WORD_SIZE];
char pronunciation[MAX_PRON_SIZE];
char explain[MAX_EXPLAIN_SIZE];
char important;

void frmMainOnLoad(void)
{
	ComponentStruct * csp;	
	
	memset( word, 0, MAX_WORD_SIZE );
	memset( pronunciation, 0, MAX_PRON_SIZE );
	memset( explain, 0, MAX_EXPLAIN_SIZE );
	important = 0;

	csp = FormGetComponentPtr( Main_Edit_Word_1006 );
	FieldEditSetBuffer( csp, word, MAX_WORD_SIZE );
	FieldEditSetCursorToRear( csp );
}

void btnGoOnClick(void)
{
	ComponentStruct* csp;
	RegionStruct *rs;
	
	memset( pronunciation, 0, MAX_PRON_SIZE );
	memset( explain, 0, MAX_EXPLAIN_SIZE );
	important = 0;
	
	if( SeekWord( word, pronunciation, explain, important ) == CVOS_OK )
	{
		csp = CPtr( Main_TextField_Explain_1015 );
		TextFieldSetBuffer( csp, (P_U8)explain ); 
		ComponentDraw(csp);
		
		csp = CPtr( Main_Label_Pron_1012 );
		rs = &(csp->Region);
		(void)DrawPron( pronunciation, rs->Left, rs->Top,  rs->Right - rs->Left );
	}
	else
	{
		csp = CPtr( Main_TextField_Explain_1015 );
		TextFieldSetBuffer( csp, "" ); 
		ComponentDraw(csp);
		
		// ȣκ . ( White)
		csp = CPtr( Main_Label_Pron_1012 );
		ComponentDraw(csp);
	}
}

void btnMeanOnClick(void)
{
	int rtnval;
	
	if( strlen( word ) )
	{
		if( ShowMeaning( word ) != CVOS_OK )
		{
			MsgBoxDo(MK_ERROR, "ERROR", "ERROR", MSGBOX_OK);
		}
	}
}


bool frmMainHandleEvent(EventStruct* e)
{
    bool handled = FALSE;

    switch (e->EventType)
    {
        case COMPONENTSELECTEVENT:
            switch (e->ObjectID)
            {
                case Main_Button_Go_1018:
                	btnGoOnClick();
                    handled = TRUE;
                    break;

                case Main_Button_Mean_1003:	
                	btnMeanOnClick();	                	
                    handled = TRUE;
                    break;
            }
            break;

    	case BUTTONREPEATEVENT :
    	case BUTTONDOWNEVENT :
            /*
        	switch( e->EventData.ID )
            {
            	case UP_BTN:
                	handled = TRUE;
                	break;

            	case DOWN_BTN:
                	handled = TRUE;
                	break;

            	case ENTER_BTN:
                	handled = TRUE;
                	break;

            	case RIGHT_BTN:
                	handled = TRUE;
                	break;
            }
            */
        	break;

    }

	return handled;
}
