/*
	withmidc.h
	ryu@pdaprogramming.com
*/

#ifndef __WITHMDIC_H_ 
	#define __WITHMIDC_H_

#ifdef __cplusplus
extern "C"{
#endif

#define MAX_WORD_SIZE			64
#define MAX_PRON_SIZE			64*2
#define MAX_EXPLAIN_SIZE	30000

#define DICT_WORD_NOT_FOUND -1

STATUS SeekDict( void );
STATUS SeekWord( char *word, char *pron, char *expl, char impo );

STATUS DrawPron( char *pron, int x, int y, int width );
STATUS ShowMeaning( char *word );

#ifdef __cplusplus
}
#endif

#endif

